using System;
using System.IO;
using System.Linq;
using System.Drawing;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace RunWithCloseBtn {
    public class Program {
        [DllImport("user32.dll")]
        public static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter, int X, int Y, int cx, int cy, uint uFlags);
        
        [DllImport("user32.dll")]
        public static extern int GetWindowLong(IntPtr hWnd, int nIndex);
        
        [DllImport("user32.dll")]
        public static extern int SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);
        
        [DllImport("user32.dll")]
        public static extern void ShowWindow(IntPtr hWnd, int nShow);
        
        [DllImport("kernel32.dll")]
        public static extern IntPtr GetConsoleWindow();

        public static void Main(string[] args){
            if(args.Length < 2){
                Console.WriteLine("Недостаточно аргументов");
                Environment.Exit(1);
            }

            if(args[0] != "-appPath"){
                Console.WriteLine("Пропущен обязательный аргумент -appPath");
                Environment.Exit(1);
            }

            if(args.Contains("-hideConsole")){
                IntPtr conWnd = GetConsoleWindow();
                if(conWnd != IntPtr.Zero) ShowWindow(conWnd, 0);
            }

            bool selByName = args.Contains("-killAll");

            Process proc = new Process();
            proc.StartInfo.FileName = args[1];

            string procName = Path.GetFileNameWithoutExtension(args[1]);

            try{
                proc.Start();
            }catch(Exception){
                Console.WriteLine("Не удалось запустить процесс");
                Environment.Exit(1);
            }

            Form form = new Form();

            form.Load += (ev, s)=>{
                form.BackColor = Color.Black;
                form.FormBorderStyle = FormBorderStyle.None;
                form.ShowInTaskbar = false;

                form.Size = new Size(50, 50);

                form.Location = new Point(Screen.PrimaryScreen.Bounds.Width - form.Width, 0);

                Label label = new Label();
                label.Size = new Size(form.Size.Width, form.Size.Height);

                try{
                    Assembly assembly = Assembly.GetExecutingAssembly();
                    using(Stream stream = assembly.GetManifestResourceStream("x.png")){
                        label.Image = Image.FromStream(stream);
                    }
                }catch(Exception){
                    Console.WriteLine("x.png не найден или имеет некорректный формат");
                    Environment.Exit(1);
                }

                form.Click += (bev, bs)=>{
                    if(selByName){
                        foreach(Process p in Process.GetProcessesByName(procName)){
                            p.Kill();
                        }
                    }else{
                        proc.Kill();
                    }
                    
                    Application.Exit();
                };

                label.Click += (bev, bs)=>{
                    if(selByName){
                        foreach(Process p in Process.GetProcessesByName(procName)){
                            p.Kill();
                        }
                    }else{
                        proc.Kill();
                    }
                    
                    Application.Exit();
                };

                form.Controls.Add(label);
            };

            form.Shown += (ev, s)=>{
                IntPtr topMost = new IntPtr(-1);
                int winLong = GetWindowLong(form.Handle, -20);

                while(true){
                    try{
                        Application.DoEvents();
                        SetWindowPos(form.Handle, topMost, 0, 0, 0, 0, 0x01 | 0x02 | 0x40);
                        SetWindowLong(form.Handle, -20, winLong | 0x80);

                        if(!selByName && proc.HasExited) Environment.Exit(0);
                    }catch(Exception){
                        break;
                    }
                }
            };

            Application.Run(form);
        }
    }
}